*     TB03AD EXAMPLE PROGRAM TEXT
*     RELEASE 4.0, WGS COPYRIGHT 1999.
*     Modified 3 February 2000 by Pierre-Olivier Malaterre
*     Modified 13 March 2000 by Pierre-Olivier Malaterre following correction by Vasile Sima
*
*     .. Parameters ..
      INTEGER          NIN, NOUT
      PARAMETER        ( NIN = 5, NOUT = 6 )
      INTEGER          NMAX, MMAX, PMAX
*     N: nb of states, M: nb of inputs, P: nb of outputs
      PARAMETER        ( NMAX = 200, MMAX = 50, PMAX = 50 )
      INTEGER          MAXMP
      PARAMETER        ( MAXMP = MAX( MMAX, PMAX ) )
      INTEGER          LDA, LDB, LDC, LDD, LDPCO1, LDPCO2, LDQCO1,
     $                 LDQCO2, LDVCO1, LDVCO2, NMAXP1
      PARAMETER        ( LDA = NMAX, LDB = NMAX, LDC = MAXMP,
     $                   LDD = MAXMP, LDPCO1 = MAXMP, LDPCO2 = MAXMP,
     $                   LDQCO1 = MAXMP, LDQCO2 = MAXMP, LDVCO1 = MAXMP,
     $                   LDVCO2 = NMAX, NMAXP1 = NMAX+1 )
      INTEGER          LIWORK
      PARAMETER        ( LIWORK = NMAX + MAXMP )
      INTEGER          LDWORK
      PARAMETER        ( LDWORK = MAX( NMAX + MAX( NMAX, 3*MAXMP ),
     $                                 MAXMP*( MAXMP + 2 ) ) )
*     .. Local Scalars ..
      DOUBLE PRECISION TOL
      INTEGER          I, INDBLK, INFO, J, K, KPCOEF, M, N, NR, P, PORM,
     $                 PORP
      INTEGER          MAT,Iflag,N1,N2,M1,P1
      CHARACTER*1      EQUIL, LERI, TYPE
      CHARACTER*4      NAME
      LOGICAL          LLERI
*     .. Local Arrays ..
      DOUBLE PRECISION A(LDA,NMAX), B(LDB,MAXMP), C(LDC,NMAX),
     $                 D(LDD,MAXMP), DWORK(LDWORK),
     $                 PCOEFF(LDPCO1,LDPCO2,NMAXP1),
     $                 QCOEFF(LDQCO1,LDQCO2,NMAXP1),
     $                 VCOEFF(LDVCO1,LDVCO2,NMAXP1)
      DOUBLE PRECISION PQ(LDPCO1,LDPCO2)
      INTEGER          INDEX(MAXMP), IWORK(LIWORK)
*     .. External Functions ..
      LOGICAL          LSAME
      EXTERNAL         LSAME
*     .. External Subroutines ..
      EXTERNAL         TB03AD
*     .. Intrinsic Functions ..
      INTRINSIC        MAX
*     .. Executable Statements ..
*
      OPEN(NIN,FILE='MTB03AD.DAT',STATUS='OLD',ERR=300)
      OPEN(NOUT,FILE='MTB03AD.RES',STATUS='UNKNOWN',ERR=300)
      WRITE ( NOUT, FMT = 99999 )
*     Skip the heading in the data file and read the data.
      READ ( NIN, FMT = '()',ERR=300)
*     We add another integer MAT on the .dat file (POM 3/2/2000)
*     MAT=0 for usual reading of the matrices on the mtb03ad.dat file
*     MAT=1 for reading of the matrices on the slicotin.mat file, writing on slicotou.mat
*     MAT=2 for reading of the matrices on the slicotin.mat file, writing on slicotou.mat + mtb03ad.res
*     We add another character TYPE on the .dat file (POM 3/2/2000)
*     TYPE=I for matrices in increasing order of powers
*     TYPE=D for matrices in decreasing order of powers
      READ ( NIN, FMT = * ,ERR=300) N,M,P,TOL,LERI,EQUIL,MAT,TYPE
      LLERI = LSAME( LERI, 'L' )
      IF ( N.LT.0 .OR. N.GT.NMAX ) THEN
         WRITE ( NOUT, FMT = 99987 ) N
      ELSE
         IF (MAT.NE.0) THEN
            CALL RDM2(A,LDA,NMAX,N1,N2,1,Iflag)
c     check if the matrix is square
            IF ( N1.NE.N2 ) THEN
               WRITE ( NOUT, FMT = 99982 )
               GOTO 300
            ENDIF
c     check if the dimension of the matrix is ok
            IF ( Iflag.EQ.-2 ) THEN
               WRITE ( NOUT, FMT = 99987 ) MAX(N1,N2)
               GOTO 300
            ENDIF
c     check if the file reading was ok
            IF ( Iflag.EQ.-1 .OR. Iflag.EQ.1 ) THEN
               WRITE ( NOUT, FMT = 99983 )
               GOTO 300
            ENDIF
c     check if the dimension of the matrix read on the .mat file is the same
c     of the one indicated on the .dat file
            IF ( N.NE.N1 .OR. N.NE.N2 ) THEN
               N=MAX(N1,N2)
               WRITE ( NOUT, FMT = 99981 ) N
            ENDIF
         ELSE
            READ ( NIN, FMT = *,ERR=300) ((A(I,J),J=1,N),I=1,N)
         ENDIF
         IF ( M.LT.0 .OR. M.GT.MMAX ) THEN
            WRITE ( NOUT, FMT = 99986 ) M
         ELSE
            IF (MAT.NE.0) THEN
               CALL RDM2(B,LDB,MAXMP,N1,M1,0,Iflag)
c     check if the dimension of the matrix is ok
               IF ( Iflag.EQ.-2 ) THEN
                  WRITE ( NOUT, FMT = 99987 ) N1
                  WRITE ( NOUT, FMT = 99986 ) M1
                  GOTO 300
               ENDIF
c     check if the file reading was ok
               IF ( Iflag.EQ.-1 .OR. Iflag.EQ.1 ) THEN
                  WRITE ( NOUT, FMT = 99983 )
                  GOTO 300
               ENDIF
c     check if the dimension of the matrix read on the .mat file is the same
c     of the one indicated on the .dat file
               IF ( N.NE.N1 ) THEN
                  N=N1
                  WRITE ( NOUT, FMT = 99981 ) N
               ENDIF
               IF ( M.NE.M1 ) THEN
                  M=M1
                  WRITE ( NOUT, FMT = 99980 ) M
               ENDIF
            ELSE
               READ ( NIN, FMT = *,ERR=300) ((B(I,J),J=1,M),I=1,N)
            ENDIF
            IF ( P.LT.0 .OR. P.GT.PMAX ) THEN
               WRITE ( NOUT, FMT = 99985 ) P
            ELSE
               IF (MAT.NE.0) THEN
                  CALL RDM2(C,LDC,NMAX,P1,N1,0,Iflag)
c     check if the dimension of the matrix is ok
                  IF ( Iflag.EQ.-2 ) THEN
                     WRITE ( NOUT, FMT = 99987 ) N1
                     WRITE ( NOUT, FMT = 99985 ) P1
                     GOTO 300
                  ENDIF
c     check if the file reading was ok
                  IF ( Iflag.EQ.-1 .OR. Iflag.EQ.1 ) THEN
                     WRITE ( NOUT, FMT = 99983 )
                     GOTO 300
                  ENDIF
c     check if the dimension of the matrix read on the .mat file is the same
c     of the one indicated on the .dat file
                  IF ( N.NE.N1 ) THEN
                     N=N1
                     WRITE ( NOUT, FMT = 99981 ) N
                  ENDIF
                  IF ( P.NE.P1 ) THEN
                     P=P1
                     WRITE ( NOUT, FMT = 99979 ) P
                  ENDIF
                  CALL RDM2(D,LDD,MAXMP,P1,M1,-1,Iflag)
c     check if the dimension of the matrix is ok
                  IF ( Iflag.EQ.-2 ) THEN
                     WRITE ( NOUT, FMT = 99986 ) M1
                     WRITE ( NOUT, FMT = 99985 ) P1
                     GOTO 300
                  ENDIF
c     check if the file reading was ok
                  IF ( Iflag.EQ.-1 .OR. Iflag.EQ.1 ) THEN
                     WRITE ( NOUT, FMT = 99983 )
                     GOTO 300
                  ENDIF
c     check if the dimension of the matrix read on the .mat file is the same
c     of the one indicated on the .dat file
                  IF ( M.NE.M1 ) THEN
                     M=M1
                     WRITE ( NOUT, FMT = 99980 ) M
                  ENDIF
                  IF ( P.NE.P1 ) THEN
                     P=P1
                     WRITE ( NOUT, FMT = 99979 ) P
                  ENDIF
               ELSE
                  READ ( NIN, FMT = *,ERR=300) ((C(I,J),J=1,N),I=1,P)
                  READ ( NIN, FMT = *,ERR=300) ((D(I,J),J=1,M),I=1,P)
               ENDIF
*              Find the right pmr which is equivalent to the ssr
*              C*inv(sI-A)*B+D.
               write(*,*) 'Call TB03AD'
               CALL TB03AD( LERI, EQUIL, N, M, P, A, LDA, B, LDB, C,
     $                      LDC, D, LDD, NR, INDEX, PCOEFF, LDPCO1,
     $                      LDPCO2, QCOEFF, LDQCO1, LDQCO2, VCOEFF,
     $                      LDVCO1, LDVCO2, TOL, IWORK, DWORK, LDWORK,
     $                      INFO )
*
               write(*,*) 'End call TB03AD'
               IF ( INFO.NE.0 ) THEN
                  WRITE ( NOUT, FMT = 99998 ) INFO
                  GOTO 300
               ELSE
                  WRITE ( NOUT, FMT = 99997 ) NR
c     write the matrix on the .mat file + a message on the .res file
                  IF (MAT.EQ.1.OR.MAT.EQ.2) THEN
                     WRITE ( NOUT, FMT = 99984 ) 'A'
                     CALL MKM2( A, 'A', 1, LDA, NR, NR, 1 )
                  ENDIF
c     write the matrix on the .res file
                  IF (MAT.EQ.0.OR.MAT.EQ.2) THEN
                     DO 20 I = 1, NR
                        WRITE ( NOUT, FMT = 99996 ) ( A(I,J), J = 1,NR )
   20                CONTINUE
                  ENDIF
                  INDBLK = 0
                  DO 40 I = 1, N
                     IF ( IWORK(I).NE.0 ) INDBLK = INDBLK + 1
   40             CONTINUE
                  WRITE ( NOUT, FMT = 99995 ) ( IWORK(I), I = 1,INDBLK )
                  WRITE ( NOUT, FMT = 99994 )
c     write the matrix on the .mat file + a message on the .res file
                  IF (MAT.EQ.1.OR.MAT.EQ.2) THEN
                     WRITE ( NOUT, FMT = 99984 ) 'B'
                     CALL MKM2( B, 'B', 1, LDB, NR, M, 0 )
                  ENDIF
c     write the matrix on the .res file
                  IF (MAT.EQ.0.OR.MAT.EQ.2) THEN
                     DO 60 I = 1, NR
                        WRITE ( NOUT, FMT = 99996 ) ( B(I,J), J = 1,M )
   60                CONTINUE
                  ENDIF
                  WRITE ( NOUT, FMT = 99993 )
c     write the matrix on the .mat file + a message on the .res file
                  IF (MAT.EQ.1.OR.MAT.EQ.2) THEN
                     WRITE ( NOUT, FMT = 99984 ) 'C'
                     CALL MKM2( C, 'C', 1, LDC, P, NR, 0 )
                  ENDIF
c     write the matrix on the .res file
                  IF (MAT.EQ.0.OR.MAT.EQ.2) THEN
                     DO 80 I = 1, P
                        WRITE ( NOUT, FMT = 99996 ) ( C(I,J), J = 1,NR )
   80                CONTINUE
                  ENDIF
                  IF ( LLERI ) THEN
                     PORM = P
                     PORP = M
                     WRITE ( NOUT, FMT = 99992 ) INDBLK
                  ELSE
                     PORM = M
                     PORP = P
                     WRITE ( NOUT, FMT = 99991 ) INDBLK
                  END IF
                  WRITE ( NOUT, FMT = 99990 ) ( INDEX(I), I = 1,PORM )
                  KPCOEF = 0
                  DO 100 I = 1, PORM
                     KPCOEF = MAX( KPCOEF, INDEX(I) )
  100             CONTINUE
                  KPCOEF = KPCOEF + 1
                  WRITE ( NOUT, FMT = 99989 )
                  IF (MAT.EQ.1.OR.MAT.EQ.2) THEN
*                    For each degree K generate the matrix PQ (for P)
                     DO 107 K = 1, KPCOEF
                        DO 106 J = 1, PORM
                           DO 105 I = 1, PORM
                              PQ(I,J)=PCOEFF(I,J,K)
  105                      CONTINUE
  106                   CONTINUE
*                       Save the matrix on the out.mat file
                        IF (TYPE.EQ.'I') THEN
*                          Increasing order of powers (ie Pi for s^i)
                           NB=KPCOEF-K
                        ELSE
*                          Decreasing order of powers (ie Pi for s^(n-i))
                           NB=K-1
                        ENDIF
                        IF (NB.LT.10) THEN
                           namlen=2
                           WRITE(NAME,'(A1,I1,2X)') 'P',NB
                        ELSEIF (NB.LT.100) THEN
                           namlen=3
                           WRITE(NAME,'(A1,I2,1X)') 'P',NB
                        ELSEIF (NB.LT.1000) THEN
                           namlen=4
                           WRITE(NAME,'(A1,I3)') 'P',NB
                        ENDIF
                        WRITE ( NOUT, FMT = 99984 ) NAME
                        CALL MKM2(PQ,NAME,namlen,LDPCO1,PORM,PORM,0)
  107                CONTINUE
c                    WRITE ( NOUT, FMT = 99984 ) 'P'
*                    Unfortunalety this MKM2 routine does not handle 3D matrices
*                    We should write one skipping the tail zeros
c                    CALL MKM2(PCOEFF,'P',1,LDPCO1*LDPCO2
c    $                        ,LDPCO1*PORM,KPCOEF,0)
                  ENDIF
                  IF (MAT.EQ.0.OR.MAT.EQ.2) THEN
                     WRITE ( NOUT, FMT = 99978 ) PORM,PORM,KPCOEF
*                    write PCOEFF ie PQ also by column (each column under the other, one column for each power)
                     DO 140 J = 1, PORM
                        DO 120 I = 1, PORM
                           WRITE ( NOUT, FMT = 99996 )
     $                           ( PCOEFF(I,J,K), K = 1,KPCOEF )
  120                   CONTINUE
  140                CONTINUE
                  ENDIF
                  WRITE ( NOUT, FMT = 99988 )

                  IF (MAT.EQ.1.OR.MAT.EQ.2) THEN
*                    For each degree K generate the matrix PQ (for Q)
                     DO 150 K = 1, KPCOEF
                        IF ( LLERI ) THEN
                           DO 146 J = 1, PORP
                              DO 145 I = 1, PORM
                                 PQ(I,J)=QCOEFF(I,J,K)
  145                         CONTINUE
  146                      CONTINUE
                        ELSE
                           DO 148 J = 1, PORM
                              DO 147 I = 1, PORP
                                 PQ(I,J)=QCOEFF(I,J,K)
  147                         CONTINUE
  148                      CONTINUE
                        ENDIF
*                       Save the matrix on the out.mat file
                        IF (TYPE.EQ.'I') THEN
*                          Increasing order of powers (ie Qi for s^i)
                           NB=KPCOEF-K
                        ELSE
*                          Decreasing order of powers (ie Qi for s^(n-i))
                           NB=K-1
                        ENDIF
                        IF (NB.LT.10) THEN
                           namlen=2
                           WRITE(NAME,'(A1,I1,2X)') 'Q',NB
                        ELSEIF (NB.LT.100) THEN
                           namlen=3
                           WRITE(NAME,'(A1,I2,1X)') 'Q',NB
                        ELSEIF (NB.LT.1000) THEN
                           namlen=4
                           WRITE(NAME,'(A1,I3)') 'Q',NB
                        ENDIF
                        WRITE ( NOUT, FMT = 99984 ) NAME
                        IF ( LLERI ) THEN
                           CALL MKM2(PQ,NAME,namlen,LDPCO1,PORM,PORP,0)
                        ELSE
                           CALL MKM2(PQ,NAME,namlen,LDPCO1,PORP,PORM,0)
                        ENDIF
  150                CONTINUE
c                    WRITE ( NOUT, FMT = 99984 ) 'Q'
*                    Unfortunalety this MKM2 routine does not handle 3D matrices
*                    We should write one skipping the tail zeros
c                    CALL MKM2(QCOEFF,'Q',1,LDQCO1*LDQCO2
c    $                        ,LDQCO1*PORP,KPCOEF,-1)
                  ENDIF
                  IF (MAT.EQ.0.OR.MAT.EQ.2) THEN
*                    write QCOEFF by row ie PQ by column (each column under the other, one column for each power)
                     WRITE ( NOUT, FMT = 99978 ) PORP,PORM,KPCOEF
                     IF ( LLERI ) THEN
                        DO 180 I = 1, PORM
                           DO 160 J = 1, PORP
                              WRITE ( NOUT, FMT = 99996 )
     $                              ( QCOEFF(I,J,K), K = 1,KPCOEF )
  160                      CONTINUE
  180                   CONTINUE
                     ELSE
                        DO 220 I = 1, PORP
                           DO 200 J = 1, PORM
                              WRITE ( NOUT, FMT = 99996 )
     $                              ( QCOEFF(I,J,K), K = 1,KPCOEF )
  200                      CONTINUE
  220                   CONTINUE
                     ENDIF
                  ENDIF
               END IF
            END IF
         END IF
      END IF
      STOP
  300 CONTINUE
      write(*,*) 'A problem occured. Please read the MTB03AD.RES file'
*
99999 FORMAT (' TB03AD EXAMPLE PROGRAM RESULTS',/1X)
99998 FORMAT (' INFO on exit from TB03AD = ',I2)
99997 FORMAT (' The order of the minimal state-space representation = ',
     $       I2,//' The transformed state dynamics matrix of a minimal',
     $       ' realization is ')
*99996 FORMAT (20(1X,F10.4))
99996 FORMAT (4(1X,D24.16))
99995 FORMAT (/' and the dimensions of its diagonal blocks are ',/20(I5)
     $       )
99994 FORMAT (/' The transformed input/state matrix of a minimal reali',
     $       'zation is ')
99993 FORMAT (/' The transformed state/output matrix of a minimal real',
     $       'ization is ')
99992 FORMAT (/' The observability index of the transformed minimal sy',
     $       'stem representation = ',I2)
99991 FORMAT (/' The controllability index of the transformed minimal ',
     $       'system representation = ',I2)
99990 FORMAT (/' INDEX is ',/20(I5))
99989 FORMAT (/' The denominator matrix P(s) is ')
99988 FORMAT (/' The numerator matrix Q(s) is ')
99987 FORMAT (/' N is out of range.',/' N = ',I5)
99986 FORMAT (/' M is out of range.',/' M = ',I5)
99985 FORMAT (/' P is out of range.',/' P = ',I5)
99984 FORMAT (' Cf Matrix ',A10,' on slicotou.mat MatLab file')
99983 FORMAT (/' Problem occured reading .mat file ')
99982 FORMAT (/' A matrix is not square ')
99981 FORMAT (/' N from .mat is selected: N = ',I5)
99980 FORMAT (/' M from .mat is selected: M = ',I5)
99979 FORMAT (/' P from .mat is selected: P = ',I5)
99978 FORMAT (/' DIM of the matrix: ',3I5)
      END
