clear

% choice of the system
%load Hsys;
load Usys;
%load Vsys;

% display of the singular values of the original system
Gsys1=ss(A,B,C,D);
subplot(2,2,1);
[S1,W1]=sigma(Gsys1);
semilogx(W1,20*log10(S1));
title('Original system - Sigma MatLab command');
xlabel('Frequency w');
ylabel('Singular values');

LERI = 'L'
TYPE = 's';
FLAG = 'tf';
SCALING = 2;

[Q,P] = TB03AD(A,B,C,D,LERI,TYPE,'m3',SCALING);
MQ = max(max(max(abs(Q))))
MP = max(max(max(abs(P))))

[Q,P] = TB03AD(A,B,C,D,LERI,TYPE,FLAG,SCALING);

% Generate singular values of Q/P for different w
% (Q0 + Q1 (iw) + Q2 (iw)^2 + ...)/(P0 + P1 (iw) + P2 (iw)^2 + ...)

for k = 1 : length(W1)
   w=W1(k);
   % computes directly D + C.inv(sI-A).B
   S2(:,k)=svd(D + C*inv(i*w*eye(size(A))-A)*B);
   % computes P0 + P1 (iw) + P2 (iw)^2 + ...
   [RE,IM] = nyquist(P,w);
   Pw=RE+j*IM;
   % computes Q0 + Q1 (iw) + Q2 (iw)^2 + ...
   [RE,IM] = nyquist(Q,w);
   Qw=RE+j*IM;
   % computes the fraction
   if LERI == 'L'
      S3(:,k)=svd(inv(Pw)*Qw);
   else
      S3(:,k)=svd(Qw*inv(Pw));
   end
end

subplot(2,2,2);
semilogx(W1,20*log10(S2));
title('Original system - D + C.inv(iw.I - A).B');
xlabel('Frequency w');
ylabel('Singular values');

subplot(2,2,3);
semilogx(W1,20*log10(S3));
if LERI == 'L'
   title('Left polynomial factorization - inv(Dl)*Nl');
else
   title('Right polynomial factorization - Nr*inv(Dr)');
end
xlabel('Frequency w');
ylabel('Singular values');

LERI = 'R'

[Q,P] = TB03AD(A,B,C,D,LERI,TYPE,'m3',SCALING);
MQ = max(max(max(abs(Q))))
MP = max(max(max(abs(P))))

[Q,P] = TB03AD(A,B,C,D,LERI,TYPE,FLAG,SCALING);
for k = 1 : length(W1)
   w=W1(k);
   % computes P0 + P1 (iw) + P2 (iw)^2 + ...
   [RE,IM] = nyquist(P,w);
   Pw=RE+j*IM;
   % computes Q0 + Q1 (iw) + Q2 (iw)^2 + ...
   [RE,IM] = nyquist(Q,w);
   Qw=RE+j*IM;
   % computes the fraction
   if LERI == 'L'
      S4(:,k)=svd(inv(Pw)*Qw);
   else
      S4(:,k)=svd(Qw*inv(Pw));
   end
end
subplot(2,2,4);
semilogx(W1,20*log10(S4));
if LERI == 'L'
   title('Left polynomial factorization - inv(Dl)*Nl');
else
   title('Right polynomial factorization - Nr*inv(Dr)');
end
xlabel('Frequency w');
ylabel('Singular values');

% compute max differences
SCALING
D2 = max(max(abs(S2-S1)))
D3 = max(max(abs(S3-S1)))
D4 = max(max(abs(S4-S1)))
